#
# gear_animate.py
#
# Open the file: gears.cb
# Then press F5 in this script.
#

import gears
from gears import *

# geardef parameters:
#
# 1 - ID of outer gear shape
# 2 - ID of center point (single point in a point list)
# 3 - number of teeth
# 4 - the tooth pitch size 
#
xgear = [ geardef(1,11,16,2),
          geardef(2,7,20,2),
          geardef(3,8,24,2),
          geardef(4,9,28,2),
          geardef(5,10,32,2),
          geardef(12,9,72,2),
          geardef(13,14,17.0,2) ]

# assume gear[0] is the driving gear, which has a relative speed of 1

# Links gears together.
# The gear number is the index in the xgear list defined above.
# for example, the following line links gear 0 and 1
# ie gear[0] drives gear[1]
xgear[1].link( xgear[0] )
xgear[3].link( xgear[0] )
xgear[4].link( xgear[0] )
xgear[2].link( xgear[3] )
# gear 5 and 3 are on the same axis, so give them the same speed
xgear[5].speed = xgear[3].speed
xgear[6].link( xgear[5] )


# radians per animation setp
th = Math.PI/180.0

# animation loop
for dd in range (1,360):

	# update each gears rotation
    for xg in xgear:
        xg.rotate(th)
    
    view.RefreshView()
    app.Sleep(10)

for xg in xgear:
    xg.reset()

	