#
# gears.py
#
# A class used to help with gear animations.
#

# imported python modules do not get default headers and imports
# so need to add all referenced assemblies here.
from CamBam.Geom import *

class geardef:
    def __init__(self,_id,_center,_teeth,_pitch):
        self.id = _id
        self.teeth = _teeth
        self.pitch = _pitch
        # d is the pitch diameter
        self.d = _teeth / _pitch
        self.ent = doc.FindPrimitive(_id)
        cp = doc.FindPrimitive(_center)
        self.c = cp.Points[0]
        self.speed=1.0

	# link this gear to another by adjusting it's
	# relative rotation speed based on pitch diameter ratio:
    def link(self,other):
        self.speed = -other.speed * other.d / self.d

	# rotate the gear about the center point by theta radians
    def rotate(self,theta):
        self.ent.Transform.Translate(-self.c.X,-self.c.Y,0)
        self.ent.Transform.RotZ(theta*self.speed)
        self.ent.Transform.Translate(self.c)

	# reset the gear rotation    
    def reset(self):
        self.ent.Transform = Matrix4x4F.Identity
        

